package jp.co.infonic.common.batch;

import java.sql.SQLException;
import java.util.Date;

import jp.co.infonic.common.db.jdbc.DBConnection;
import jp.co.infonic.common.db.jdbc.DataSourceManager;
import jp.co.infonic.common.module.log.BatchLogger;

public abstract class CnkBatch implements Runnable {
	
	// sԂ܂ł̎c莞ԁij
	private int timer;
	
	// stO
	private boolean synchronous = true;
	
	// sԊuij
	private int period = 1;
	
	// Osԁi~bj
	private long lastTime;
	
	// ^XNLtO
	private boolean processing = false;
	
	// sID
	private String id;
	
	// sIDZbgB
	final void setId(String id) {
		this.id = id;
	}
	
	/**
	 * Tv: ݂s\ǂԂtO<br>
	 * ڍ: ݂s\ǂԂtO<br>
	 *       trueԂꍇAsB<br>
	 *       I[o[Ch鎖ŒsȊO<br>
	 *       twss悤ɐݒłB<br>
	 * l: Ȃ<br>
	 *
	 * @param current
	 * @return
	 */
	boolean isExeTime(long current) {
		return timer <= 0;
	}
	
	// sԃ^C}[̃JEg_E
	final void countdown() {
		timer--;
	}
	
	// tOԂ
	final boolean isSynchronous() {
		return synchronous;
	}

	/**
	 * Tv: ̃^XN̎sJn܂B<br>
	 * ڍ: ̃^XN̎sJn܂B<br>
	 *       s^C}[periodŏ܂B<br>
	 * l: Ȃ<br>
	 */
	public final void start() {
		processing = true;
	}

	/**
	 * Tv: ̃^XN̎sꎞ~܂B<br>
	 * ڍ: ̃^XN̎sꎞ~܂B<br>
	 * l: Ȃ<br>
	 */
	public final void pause() {
		processing = false;
	}
	
	/**
	 * Tv: sIDԂB<br>
	 * ڍ: sIDԂB<br>
	 * l: Ȃ<br>
	 * @return
	 */
	public final String getId() {
		return id;
	}

	/**
	 * Tv: OsԂԂB <br>
	 * ڍ: OsԂt^ƂĕԂB <br>
	 * l: Ȃ<br>
	 */
	public Date getLasttime() {
		if (lastTime == 0) {
			return null;
		}
		return new Date(lastTime);
	}

	/**
	 * Tv: sԂ̊ԊuԂB<br>
	 * ڍ: sԂ̊ԊuԂB<br>
	 *       Pʂ͕B<br>
	 * l: Ȃ<br>
	 */
	public int getPeriod() {
		return period;
	}
	
	/**
	 * 
	 * Tv: sԊu̕\ԂB<br>
	 * ڍ: sԊu̕\ԂB<br>
	 *       ȊOŎsꍇA\bh<br>
	 *       I[o[ChB<br>
	 * l: Ȃ<br>
	 *
	 * @return
	 */
	public String getTiming() {
		return period + "";
	}

	/**
	 * Tv: sԂ܂ł̎c莞ԂԂB<br>
	 * ڍ: sԂ܂ł̎c莞ԂԂB<br>
	 * l: Ȃ<br>
	 */
	public int getNextTime() {
		return timer;
	}

	/**
	 * Tv: sԂ܂ł̎ԂĐݒ肷B<br>
	 * ڍ: sԂ܂ł̎ԂĐݒ肷B<br>
	 *       Pʂ͕B<br>
	 * l: Ȃ<br>
	 */
	public void setNextTime(int minute) {
		timer = minute;
	}

	/**
	 * Tv: sԊuĐݒ肷B<br>
	 * ڍ: sԊuĐݒ肷B<br>
	 *       Pʂ͕B<br>
	 * l: Ȃ<br>
	 */
	public void setPeriod(int minute) {
		period = minute;
	}

	/**
	 * Tv: ݎsǂԂB<br>
	 * ڍ: ݎsǂԂB<br>
	 *       true  ˁ@s<br>
	 *       false ˁ@~<br>
	 * l: Ȃ<br>
	 */
	public boolean isProcessing() {
		return processing;
	}
	
	/**
	 * ob`sʂԂB
	 * @return
	 */
	public int getResult() {
		return result;
	}

	/**
	 * ^XN̎sꃁ\bh
	 */
	public void run() {
		
		BatchLogger logger = null;
		try {
			logger = BatchLogger.getLogger(this.getClass());
			logger.start();
			
			result = execute();
			
		} catch (Exception e) {
			logger.error(e);
			result = STATUS_ERROR;
		} finally {
			
			lastTime = System.currentTimeMillis();
		}
		if (logger != null) {
			logger.end(result);
		}
	}
	
	// 
	private int result;

	/**
	 * 
	 * Tv: sԂ܂ł̃^C}[ZbgB<br>
	 * ڍ: sԂ܂ł̃^C}[ZbgB<br>
	 * l: Ȃ<br>
	 */
	protected void reset() {
		timer = period;
	}
	
	/**
	 * RXgN^
	 * @param period sԊu
	 */
	public CnkBatch(int period) {
		if (period < 1) {
			throw new IllegalArgumentException("sԊu͂PȏłȂ΂܂B");
		}
		this.period = period;
		this.timer = period;
	}
	
	/**
	 * RXgN^
	 * @param name ob`
	 * @param period sԊu
	 * @param synchronous stO true: false:񓯊
	 */
	public CnkBatch(int period, boolean synchronous) {
		this(period);
		this.synchronous = synchronous;
	}

	/**
	 * Tv: ob`ԂB<br>
	 * ڍ: ob`ԂB<br>
	 * l: Ȃ<br>
	 */
	public abstract String getName();
	
	/**
	 * 
	 * Tv: ob`̐ԂB<br>
	 * ڍ: ob`̐ԂB<br>
	 * l: Ȃ<br>
	 *
	 * @return
	 */
	public abstract String getDescription();
	
	/**
	 * Tv: C<br>
	 * ڍ: C<br>
	 * l: Ȃ<br>
	 *
	 * @return
	 */
	protected abstract int execute() throws Exception;
	
	/**
	 * Tv: ob`pDBRlNV擾<br>
	 * ڍ: ob`pDBRlNV擾<br>
	 * l: Ȃ<br>
	 *
	 * @return
	 * @throws SQLException 
	 */
	protected DBConnection getConnection(boolean autoCommit) throws SQLException {
		if (onServer) {
			return DataSourceManager.getConnection(this.getClass(), autoCommit);
		} else {
			return BatchDetaSourceManager.getConnection(autoCommit);
		}
	}

	/**
	 * 
	 * Tv: C֐<br>
	 * ڍ: APT[oƕʃvZXƂĎsꍇ̊ꃁ\bh<br>
	 * l: Ȃ<br>
	 *
	 * @param args
	 * @see jp.co.infonic.cnksystem.parts.schedule.CnkBatch#main(java.lang.String[])
	 */
	public static void main(String[] args) {
		
		if (args.length < 1) {
			System.out.print("usage: java CnkBatch batchname...");
			System.exit(0);
		}
		
		int status;
		BatchLogger logger = null;
		try {
			CnkBatch batch = (CnkBatch)Class.forName(args[0]).newInstance();
			batch.onServer = false;
			logger = BatchLogger.getLogger(batch.getClass());
			logger.start();
			
			status = batch.execute();
			
		} catch (Exception e) {
			status = 1;
			if (logger != null) {
				logger.exception(e);
			}
		}
		
		if (logger != null) {
			logger.end(status);
		}
		
		System.exit(status);
	}
	
	protected boolean onServer = true;
	
	// :OK
	public final static int STATUS_NORMAL = 0;
	
	// :NG
	public final static int STATUS_ERROR = 1;
}
