package jp.co.infonic.common.db.jdbc;

import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.SQLException;
import java.util.ArrayList;
import java.util.List;

import jp.co.infonic.common.db.SqlObj;
import jp.co.infonic.common.module.log.DebugLogger;
import jp.co.infonic.common.util.Assertion;

import org.apache.log4j.Logger;

/**
 * 
 * TvFcaRlNVbpNX<br>
 * ڍׁFcaRlNVbpNX<br>
 * ̃NX̃\bh̓}`Xbh<br>
 * T|[gĂ܂B<br>
 * 
 * <pre>
 *   [ύX]
 *   t        A   O      e
 *   --------------------------------------------------
 *   2006/03/20  VL000        VK
 * </pre>
 * 
 * @author higuchit
 */
public class DBConnection {

	// DBւConnectionCX^X
	private Connection connection = null;

	// I[gR~bg
	private boolean autoCommit;

	// gUNVJntO
	private boolean transaction = false;

	// RlNV쐬NX
	private Class className;

	private List preStateList;

	// lXggUNVpqcaRlNV
	private List childCon;
	
	// êcaRlNV
	private DBConnection parent;
	
	private String dataSourceName;
	
	// fobOK[
	private Logger logger = DebugLogger.getLogger(this.getClass());

	/**
	 * RXgN^
	 * 
	 * @param con
	 * @param autoCommit
	 */
	DBConnection(Connection con, Class cla, boolean autoCommit) {
		Assertion.isNotNull(cla, "NXnullłB");
		
		this.connection = con;
		this.className = cla;
		this.autoCommit = autoCommit;
		preStateList = new ArrayList();
	}

	/**
	 * lXggUNVpRXgN^
	 * 
	 * @param con
	 * @param autoCommit
	 */
	DBConnection(DBConnection parent, Connection con, Class cla, boolean autoCommit) {
		Assertion.isNotNull(cla, "NXnullłB");

		this.parent = parent;
		this.connection = con;
		this.className = cla;
		this.autoCommit = autoCommit;
		preStateList = new ArrayList();
	}
	
	void setDataSourceName(String name) {
		this.dataSourceName = name;
	}
	
	String getDataSourceName() {
		return this.dataSourceName;
	}

	/**
	 * 
	 * Tv: lXgꂽgUNVׂ̈̃RlNVqɃZbg<br>
	 * ڍ: lXgꂽgUNVׂ̈̃RlNVqɃZbg<br>
	 * l: Ȃ<br>
	 * 
	 * @param con
	 */
	void setChildCon(DBConnection con) {
		if (childCon == null) {
			childCon = new ArrayList();
		}
		
		childCon.add(con);
	}
	
	/**
	 * 
	 * Tv: lXgꂽgUNVׂ̈̃RlNV폜B<br>
	 * ڍ: lXgꂽgUNVׂ̈̃RlNV폜B<br>
	 * l: Ȃ<br>
	 *
	 * @param con
	 */
	void removeChildCon(DBConnection con) {
		if (childCon != null && childCon.contains(con)) {
			childCon.remove(con);
		}
	}

	/**
	 * 
	 * Tv: gUNVJnĂ邩ǂ`FbNB<br>
	 * ڍ: gUNVJnĂ邩ǂ`FbNB<br>
	 * l: Ȃ<br>
	 * 
	 * @return
	 */
	boolean isReadyExecute() {
		if (autoCommit) {
			return true;
		} else if (transaction) {
			return true;
		} else {
			return false;
		}
	}
	
	/**
	 * 
	 * Tv: vyAhXeCggXgΏۂ̃XeCgg폜B<br>
	 * ڍ: vyAhXeCggXgΏۂ̃XeCgg폜B<br>
	 * l: Ȃ<br>
	 *
	 * @param preState
	 */
	void removePreState(DBPreparedStatement preState) {
		if (preStateList.contains(preState)) {
			preStateList.remove(preState);
		}
	}

	/**
	 * 
	 * Tv: gUNVJnɌĂяoB<br>
	 * ڍ: gUNVJnɌĂяoB<br>
	 * l: Ȃ<br>
	 * 
	 */
	public void transactionStart() {

		checkConnection();

		if (!autoCommit) {

			// gUNVɊJnĂ
			if (!transaction) {
				// gUNV̊JntOON
				transaction = true;
			} else {
				String msg = "lXggUNVm܂B,ďoNX="
						+ className.getName();
				
				logger.error(msg);
			}

		}
	}

	/**
	 * 
	 * Tv: vyAhXeCgg擾܂B<br>
	 * ڍ: vyAhXeCgg擾܂B<br>
	 * l: Ȃ<br>
	 * 
	 * @param sqlObj
	 * @param replaceStr
	 * @return
	 * @throws SQLException
	 */
	public DBPreparedStatement prepareStatement(SqlObj sqlObj)
			throws SQLException {
		return prepareStatement(sqlObj, new String[0]);
	}

	/**
	 * 
	 * Tv: vyAhXeCgg擾܂B<br>
	 * ڍ: vyAhXeCgg擾܂B<br>
	 *       SQL̒uΏەFuƒu<br>
	 *       쐬܂B
	 *       u̒u@
	 *       SQL {1},{2},c{n} ꂼ
	 *       {1} -> [0], {2} -> [1]
	 *       ƒu܂B
	 * <br>
	 * l: Ȃ<br>
	 * 
	 * @param sqlObj SQLIuWFNg
	 * @param replaceStr u
	 * @return
	 * @throws SQLException
	 */
	public DBPreparedStatement prepareStatement(SqlObj sqlObj,
			String[] replaceStr) throws SQLException {

		checkConnection();

		String sql = sqlObj.getSqlString(replaceStr);

		PreparedStatement prepared = connection.prepareStatement(sql);
		DBPreparedStatement preState = new DBPreparedStatement(this, prepared, className, sql);

		this.preStateList.add(preState);

		return preState;
	}

	/**
	 * 
	 * Tv: gUNV[obN܂B<br>
	 * ڍ: gUNV[obN܂B<br>
	 * l: Ȃ<br>
	 * 
	 * @throws SQLException
	 */
	public void rollback() throws SQLException {

		checkConnection();

		if (autoCommit) {
			throw new IllegalStateException("R~bg[hłB");

		} else {
			// [obN
			this.connection.rollback();
			// gUNV̊JntOOFF
			this.transaction = false;
		}
	}

	/**
	 * 
	 * Tv: gUNVR~bg܂B<br>
	 * ڍ: gUNVR~bg܂B<br>
	 * l: Ȃ<br>
	 * 
	 * @throws SQLException
	 */
	public void commit() throws SQLException {

		checkConnection();

		// R~bg
		this.connection.commit();
		// gUNV̊JntOOFF
		this.transaction = false;
	}

	/**
	 * 
	 * Tv: RlNVN[Y܂B<br>
	 * ڍ: RlNVN[Y܂B<br>
	 * ̃RlNV쐬ꂽXeCgg<br>
	 * SăN[Y܂B<br>
	 * l: Ȃ<br>
	 * 
	 * @throws SQLException
	 */
	public void close() throws SQLException {

		// O𑱂邽߁AŏɔOێ
		SQLException se = null;

		// null̏ꍇ̓N[Y
		if (this.connection == null) {
			return;
		}
		
		// lXgĎ擾ꂽRlNVSĕ
		if (childCon != null) {
			for (int i = 0; i < childCon.size(); i++) {
				try {
					DBConnection child = (DBConnection) childCon.get(i);
					child.isClosed();
				} catch (SQLException sqe) {
					if (se == null) {
						se = sqe;
					}
				}
			}
		}

		// Xg̃vyAhXeCggSN[Y
		for (int i = 0; i < this.preStateList.size(); i++) {
			DBPreparedStatement preState = (DBPreparedStatement)preStateList.get(i);
			try {
				preState.cascadeClose();
				
			} catch (SQLException e) {
				if (se == null) {
					se = e;
				}
			}
		}

		// R~bgA[obNŘo
		if (transaction) {
			String msg = "R~bg܂̓[obNRm܂B[obN܂B,ďoNX=" + className.getName();

			logger.error(msg);
			
			try {
				// [obN
				connection.rollback();
				transaction = false;
			} catch (SQLException e) {
				if (se == null) {
					se = e;
				}
			}
		}

		try {
			// RlNṼN[Y
			connection.close();
			this.connection = null;
		} catch (SQLException e) {
			if (se == null) {
				se = e;
			}
		}
		
		if (parent != null) {
			parent.removeChildCon(this);
			parent = null;
		}

		// OĂ΃X[
		if (se != null) {
			throw se;
		}
	}

	/**
	 * 
	 * Tv: RlNVN[YĂ邩肵܂B<br>
	 * ڍ: RlNVN[YĂ邩肵܂B<br>
	 * l: Ȃ<br>
	 * 
	 * @return N[Yς݁Ftrue N[YR:false
	 * @throws SQLException
	 */
	boolean isClosed() throws SQLException {

		if (this.connection != null) {

			this.close();

			String msg = "N[YRꔭm܂B,ďoNX=" + className.getName() + " Xbh=" + Thread.currentThread().getName();
			
			logger.error(msg);
			
			return false;
		} else {
			return true;
		}
	}

	/**
	 * Tv: RlNVN[YĂ邩`FbN܂B<br>
	 * ڍ: RlNVN[YĂ邩`FbN܂B<br>
	 * ɃN[YĂꍇIllegalStateException𑗏o܂B<br>
	 * l: Ȃ<br>
	 * 
	 */
	private void checkConnection() {
		if (connection == null) {
			throw new IllegalStateException("RlNVN[YĂ܂B");
		}
	}

}
