package jp.co.infonic.common.db.jdbc;

import java.io.StringReader;
import java.math.BigDecimal;
import java.sql.Blob;
import java.sql.Date;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.ResultSetMetaData;
import java.sql.SQLException;
import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import jp.co.infonic.common.module.log.DBAccessLogger;

/**
 * 
 * TvFvyAhXeCggbvNX<br>
 * ڍׁFvyAhXeCggbvNX<br>
 *       ̃NXDBConnectionNXɂăCX^X<br>
 *       DBւ̃NG̔sp̋@\񋟂܂B<br>
 *<pre>
 * [ύX]
 * t        A   O      e
 * --------------------------------------------------
 * 2006/03/22  VL000        VK
 *</pre>
 * @author higuchit
 */
public class DBPreparedStatement {

	// vyAhXeCgg
	private PreparedStatement preState;

	// ̃CX^X𐶐RlNV
	private DBConnection conn;

	// ̃CX^X𐶐ĂяoNX
	private Class className;

	// SQL
	private String sql;

	// Bindϐu
	private String[] bind;

	// UgZbgXg
	private List resultSetList = new ArrayList();
	
	// SQLs󋵃K[
	private DBAccessLogger logger;

	/**
	 * RXgN^
	 * 
	 * @param con
	 * @param prepared
	 * @param cla
	 * @param sqlStr
	 */
	DBPreparedStatement(DBConnection con, PreparedStatement prepared,
			Class cla, String sqlStr) {
		this.preState = prepared;
		this.conn = con;
		this.sql = sqlStr;
		className = cla;
		bind = new String[countParamNum(sql)];
		logger = DBAccessLogger.getLogger(className);
	}

	/**
	 * 
	 * Tv: ̃vyAhXeCggN[Y܂B<br>
	 * ڍ: ̃vyAhXeCggN[Y܂B<br>
	 * l: Ȃ<br>
	 * 
	 * @throws SQLException
	 */
	public void close() throws SQLException {
		if (preState != null) {
			preState.close();
			conn.removePreState(this);
			conn = null;
		}

		preState = null;
	}

	/**
	 * 
	 * Tv: UgZbgSăN[YB<br>
	 * ڍ: UgZbgSăN[YB<br>
	 * l: Ȃ<br>
	 * 
	 * @throws SQLException
	 */
	void cascadeClose() throws SQLException {

		SQLException sqe = null;

		for (int i = 0; resultSetList.size() > i; i++) {
			try {
				DBResultSet rs = (DBResultSet) resultSetList.get(i);
				rs.close();

			} catch (SQLException se) {
				if (sqe == null) {
					sqe = se;
				}
			}
		}

		this.close();

		if (sqe != null) {
			throw sqe;
		}
	}

	/**
	 * 
	 * Tv: UgZbgXgΏۂ̃UgZbg폜܂B<br>
	 * ڍ: UgZbgXgΏۂ̃UgZbg폜܂B<br>
	 * l: Ȃ<br>
	 * 
	 * @param rs
	 */
	void removeResultSet(DBResultSet rs) {

		if (resultSetList.contains(rs)) {
			resultSetList.remove(rs);
		}
	}
	
	/**
	 * Tv: SQLs܂B<br>
	 * ڍ: ʂԂ܂B<br>
	 * l: Ȃ<br>
	 * @return
	 * @throws SQLException
	 * @since 2006/04/15
	 */
	public void execute() throws SQLException {

		long start = System.currentTimeMillis();
		preState.execute();

		long end = System.currentTimeMillis();
		// SQL̔s󋵃Oo͂B
		logger.info("##execute## " + getReplaceSql(), start, end);
	}

	/**
	 * Tv: INSERT,UPDATE,DELETE s܂BʌԂ܂B<br>
	 * ڍ: INSERT,UPDATE,DELETE s܂BʌԂ܂B<br>
	 * l: Ȃ<br>
	 * 
	 * @return ʌ
	 * @throws SQLException
	 */
	public int executeUpdate() throws SQLException {

		checkStatement();

		if (!conn.isReadyExecute()) {
			throw new IllegalStateException("gUNVJnĂ܂ ĂяoF"
					+ className.getName());
		}

		long start = System.currentTimeMillis();
		// SQLs
		int result = preState.executeUpdate();
		
		long end = System.currentTimeMillis();
		// SQL̔s󋵃Oo͂B
		logger.info("##executeUpdate## " + getReplaceSql(), start, end);

		return result;
	}

	/**
	 * 
	 * Tv: SQLsʃZbgԂ܂B<br>
	 * ڍ: SQLsʃZbgԂ܂B<br>
	 * l: Ȃ<br>
	 * 
	 * @return
	 * @throws SQLException
	 */
	public DBResultSet executeQuery() throws SQLException {

		checkStatement();
		
		long start = System.currentTimeMillis();
		// SQLs
		ResultSet rs = preState.executeQuery();
		
		long end = System.currentTimeMillis();
		// SQL̔s󋵃Oo͂B
		logger.info("##executeQuery## " + getReplaceSql(), start, end);

		DBResultSet resultSet = new DBResultSet(rs, this);

		resultSetList.add(resultSet);

		return resultSet;
	}
	
	/**
	 * 
	 * Tv: SQLsOracleWAVE DASHɑΉʃZbgԂ܂B<br>
	 * ڍ: SQLsOracleWAVE DASHɑΉʃZbgԂ܂B<br>
	 * l: Ȃ<br>
	 * 
	 * @return
	 * @throws SQLException
	 */
	public DBResultSet executeQueryForWaveDashEncode() throws SQLException {

		checkStatement();
		
		long start = System.currentTimeMillis();
		// SQLs
		ResultSet rs = preState.executeQuery();
		
		long end = System.currentTimeMillis();
		// SQL̔s󋵃Oo͂B
		logger.info("##executeQuery## " + getReplaceSql(), start, end);

		DBResultSet resultSet = new DBResultSetForWaveDashEncode(rs, this);

		resultSetList.add(resultSet);

		return resultSet;
	}

	/**
	 * Tv: rpk𔭍s}bvƂāAʃZbgԂ܂B<br>
	 * ڍ: rpk𔭍s}bvƂāAʃZbgԂ܂B<br>
	 * l: Ȃ<br>
	 *       }bv̍\
	 *       Map(J1, List) , (J2, List), (J3, List)
	 *       List̒ɂPڂ`ŏIR[h܂ł̒li[Ă܂B
	 *
	 * @param params oChϐ
	 * @return
	 * @throws SQLException
	 */
	public Map executeQueryForMap(Object[] params) throws SQLException {

		DBResultSet rs = null;
		try {
			setBindDataAll(params);
			rs = executeQuery();

			ResultSetMetaData rsmd = rs.getMetaData();
			Map map = new HashMap();

			while (rs.next()) {

				for (int columIndex = 1; columIndex <= rsmd.getColumnCount(); columIndex++) {
					String columnName = rsmd.getColumnName(columIndex);
					List columnList = (List) map.get(columnName);
					if (columnList == null) {
						columnList = new ArrayList();
						map.put(columnName, columnList);
					}

					columnList.add(rs.getObject(columIndex));
				}
			}

			return map;

		} finally {
			if (rs != null) {
				rs.close();
			}
		}
	}

	/**
	 * Tv: rpk𔭍sXgƂāAʃZbgԂ܂B<br>
	 * ڍ: rpk𔭍sXgƂāAʃZbgԂ܂B<br>
	 * l: Ȃ<br>
	 *       Xg̍\
	 *       
	 *       1    Map(J, Pڂ̒l)
	 *       2    Map(J, Qڂ̒l)
	 *       3    Map(J, Rڂ̒l)
	 *       4    Map(J, Sڂ̒l)
	 *       
	 *       L̂悤Map̔z񂪃Xg̒Ɋi[Ă܂B
	 *
	 * @param params oChϐ
	 * @return
	 * @throws SQLException
	 */
	public List executeQueryForList(Object[] params) throws SQLException {

		DBResultSet rs = null;
		try {
			setBindDataAll(params);
			rs = executeQuery();

			ResultSetMetaData rsmd = rs.getMetaData();
			List list = new ArrayList();

			while (rs.next()) {

				Map record = new HashMap();
				
				for (int columIndex = 1; columIndex <= rsmd.getColumnCount(); columIndex++) {
					String columnName = rsmd.getColumnName(columIndex);
					record.put(columnName, rs.getObject(columIndex));
				}
				
				list.add(record);
			}

			return list;

		} finally {
			if (rs != null) {
				rs.close();
			}
		}
	}

	/**
	 * Tv: w肳ꂽp[^XeCggɃZbg܂B<br>
	 * ڍ: w肳ꂽp[^XeCggɃZbg܂B<br>
	 * l: Ȃ<br>
	 * 
	 * @param parameterIndex
	 * @param s
	 * @throws SQLException
	 */
	public void setString(int parameterIndex, String s) throws SQLException {
		
		if (s == null) {
			throw new IllegalArgumentException("p[^nullłB");
		}

		/*
		 * Zbg悤ƂĂf[^AJDBChCoVARCHAR^̕
		 * ꍇAsetStringł̓G[ƂȂׁAsetCharacterStream𗘗p
		 */
		if (s.getBytes().length > 667) {
			preState.setCharacterStream(parameterIndex, new StringReader(s),
					4000);
		} else {
			preState.setString(parameterIndex, s);
		}
		
		bind[parameterIndex - 1] = s;

	}

	/**
	 * 
	 * Tv: vyAhXeCgg̃oChϐƒlϊ܂B<br>
	 * ڍ: vyAhXeCgg̃oChϐƒlϊ܂B<br>
	 * l: Ȃ<br>
	 * 
	 * @param params
	 * @throws SQLException
	 */
	public void setBindDataAll(Object[] params) throws SQLException {

		// null̏ꍇsȂB
		if (params == null) {
			return;
		}

		for (int i = 0; i < params.length; i++) {
			Object x = params[i];
			int paramIndex = i + 1;
			if (x == null) {
				throw new IllegalArgumentException("p[^nullłBindex :" + i);
			} else if (x instanceof String) {
				setString(paramIndex, (String) x);
			} else if (x instanceof Date) {
				preState.setDate(paramIndex, (Date) x);
			} else if (x instanceof Integer) {
				preState.setInt(paramIndex, ((Integer) x).intValue());
			} else if (x instanceof BigDecimal) {
				preState.setBigDecimal(paramIndex, (BigDecimal) x);
			} else if (x instanceof Blob) {
				preState.setBlob(paramIndex, (Blob) x);
			} else if (x instanceof java.util.Date) {
				preState.setTimestamp(paramIndex, new Timestamp(((java.util.Date)x).getTime()));
			} else {
				throw new IllegalArgumentException(
						"̌^T|[gĂȂ^łB index :" + i + " ^ :"
								+ x.getClass().getName());
			}

			bind[i] = x.toString();
		}
	}

	/**
	 * 
	 * Tv: vyAhXeCgg̃oChϐƒlϊ܂B<br>
	 * ڍ: vyAhXeCgg̃oChϐƒlϊ܂B<br>
	 * l: Ȃ<br>
	 * 
	 * @param paramList
	 * @throws SQLException
	 */
	public void setBindDataAll(List paramList) throws SQLException {
		setBindDataAll(paramList.toArray(new Object[0]));
	}

	/**
	 * Tv: vyAhXeCggN[YĂ邩`FbN܂B<br>
	 * ڍ: vyAhXeCggN[YĂ邩`FbN܂B<br>
	 * ɃN[YĂꍇIllegalStateException𑗏o܂B<br>
	 * l: Ȃ<br>
	 * 
	 */
	private void checkStatement() {
		if (preState == null) {
			throw new IllegalStateException("vyAhXeCggN[YĂ܂B");
		}
	}
	
	/**
	 * 
	 * Tv: SQL̃oChϐZbgꂽɒu܂B<br>
	 * ڍ: SQL̃oChϐZbgꂽɒu܂B<br>
	 * l: Ȃ<br>
	 *
	 * @return
	 */	
	private String getReplaceSql() {
		
		String result = sql;
		int offset = 0;
		for (int i = 0; i < bind.length; i++) {
			if ((offset = result.indexOf("?", offset)) != -1) {
				String before = result.substring(0, offset);
				if (offset + 1 < result.length()) {
					result = before + "'" + bind[i] + "'" + result.substring(offset + 1);
					offset += bind[i].length() + 2;
				} else {
					result = before + "'" + bind[i] + "'";
				}
			}
		}
			
		return result;
	}
	

	/**
	 * 
	 * Tv: SQL̃oChϐhHȟJEg܂B<br>
	 * ڍ: SQL̃oChϐhHȟJEg܂B<br>
	 * l: Ȃ<br>
	 * 
	 * @param sql
	 * @return
	 */
	private int countParamNum(String sql) {

		int result = 0;
		int start = 0;
		while ((start = sql.indexOf("?", start)) != -1) {
			result++;
			start++;
		}
		return result;
	}

}
