package jp.co.infonic.common.db.jdbc;

import java.sql.Connection;
import java.sql.DriverManager;
import java.sql.SQLException;
import java.util.HashMap;
import java.util.Iterator;
import java.util.Map;

import javax.naming.InitialContext;
import javax.naming.NamingException;
import javax.sql.DataSource;

import jp.co.infonic.common.db.jdbc.properties.ConnectPropeties;
import jp.co.infonic.common.module.log.DebugLogger;
import jp.co.infonic.common.util.Assertion;

/**
 * 
 * TvFf[^\[XǗ<br>
 * ڍׁFf[^\[XǗBcaڑꌳIɊǗ܂B<br>
 *       JDBChCoɂcaڑ̊eNXbvA<br>
 *       Ԃ܂B擾ꂽCX^Xւ̎QƂ̓f[^\[XǗNXɂ<br>
 *       ꌳǗA\[X̃N[YRh܂B<br>
 *       <br>
 *       = p@ =<br>
 *       <br>
 *       DBConnection conn = null;<br>
 *       try {<br>
 *       	// RlNV擾 ReLXgv[OꂽRlNV擾܂B<br>
 *       	conn = DataSourceManager.getConnection(this.getClass(), DataSourceManager.DS_NAME_ORACLE, true);<br>
 *<br>       
 *       	// SQL}l[WSQL擾<br>
 *        	SqlObj sql = SqlManager.getSql(this.getClass(), "LoginCheckSql");<br>
 *<br>        
 *        	// vyAhXeCgg擾<br>
 *       	DBPreparedStatement preState = conn.prepareStatement(sql);<br>
 *<br>       
 *       	// oChϐɒl𖄂ߍ<br>
 *       	preState.setString(1, "userId");<br>
 *       			c<br>
 *<br>       
 *       	// ʃZbg̎擾<br>
 *       	DBResultSet result = preState.executeQuery();<br>
 *<br>       
 *       	// \[X̃N[Y<br>
 *       	result.close();<br>
 *<br>       
 *       	preState.close();<br>
 *<br>       	
 *       } catch (SQLException sqe) {<br>
 *       } finally {<br>
 *       	if (conn != null) {<br>
 *				try {<br>
 *					conn.close();<br>
 *				} catch (Exception e) {<br>
 *					e.printStackTrace();<br>
 *					APErrorLogger apError = APErrorLogger.getLogger();<br>
 *					apError.outputErrorLog(this.getClass().getName(),"execute", "Connection close failed", false, null ,e);<br>
 *				}<br>
 *       	}<br>
 *       }<br>
 * <br>
 * 
 * <pre>
 *   [ύX]
 *   t        A   O      e
 *   --------------------------------------------------
 *   2006/03/20  VL000        VK
 * </pre>
 * 
 * @author higuchit
 */
public final class DataSourceManager {

	/** f[^\[XFORACLE JDBC */
	public static String DS_NAME_DEFAULT = "DS_DEFAULT_JDBC";

	// Xbh[Jϐ f[^\[Xێ
	private static ThreadLocal threadLocal = new ThreadLocal();

	// L[FNX
	private static final String CLASS_NAME = "CLASSNAME";

	// L[FRlNV
	private static final String DS_CONNECTION = "DS_CONNECTION";
	
	private static final String DRIVER_NAME = "DRIVER_NAME";
	
	private static ConnectPropeties prop;
	
	public static synchronized void setProperties(ConnectPropeties p) {
		Assertion.isNotNull(p);
		prop = p;
	}
	
	public static DBConnection getConnection(Class self, boolean autoCommit) throws SQLException {
		return getConnection(self, DS_NAME_DEFAULT, autoCommit);
	}
	
	/**
	 * 
	 * Tv: RlNV擾܂B
	 * 
	 * @param self
	 * @param detaSourceName
	 * @param autoCommit
	 * @return
	 * @throws SQLException
	 * @throws
	 */
	public static DBConnection getConnection(Class self, String detaSourceName,
			boolean autoCommit) throws SQLException {

		checkBeforeConnection(getDsManageMap(), detaSourceName);

		Connection connection = prop == null
									? getConnection(detaSourceName, autoCommit)
									: getConnection(autoCommit);
				
		if (connection != null) {
			DBConnection con = new DBConnection(connection, self, autoCommit);
			con.setDataSourceName(detaSourceName);

			Map map = new HashMap();
			map.put(DS_CONNECTION, con);
			map.put(CLASS_NAME, self);
			getDsManageMap().put(detaSourceName, map);
			
			return con;
		}

		throw new SQLException("Create Connection Missing");
			
	}

	/**
	 * 
	 * Tv: lXgꂽgUNVׂ̈̃RlNV擾B<br>
	 * ڍ: lXgꂽgUNVׂ̈̃RlNV擾B<br>
	 * l: Ȃ<br>
	 * 
	 * @param self
	 * @param detaSourceName
	 * @param parent
	 * @return
	 * @throws SQLException
	 */
	public static DBConnection getConnection(Class self, DBConnection parent) throws SQLException {
		if (parent == null) {
			throw new IllegalArgumentException("eRlNVnullłB");
		}

		Connection connection = getConnection(parent.getDataSourceName(), false);

		if (connection != null) {
			DBConnection con = new DBConnection(parent, connection, self, false);

			parent.setChildCon(con);
			return con;
		}

		throw new SQLException("Create Connection Missing");
	}

	/**
	 * 
	 * Tv: RlNṼN[YR`FbN܂B<br>
	 * ڍ: RlNṼN[YR`FbN܂B N[YĂtrueԂ܂B
	 * N[YȐꍇ̓N[YfalseԂ܂B<br>
	 * l: Ȃ<br>
	 * 
	 * @return N[Yς:true N[YR:false
	 */
	public static boolean checkClosed() {

		boolean result = true;
		Map dsManMap = (Map) threadLocal.get();
		if (dsManMap == null) {
			// RlNV擾̏ꍇtrue
			return result;
		}

		Iterator iter = dsManMap.keySet().iterator();
		while (iter.hasNext()) {
			try {
				Map dsMap = (Map) iter.next();

				DBConnection conn = (DBConnection) dsMap.get(DS_CONNECTION);
				if (!conn.isClosed()) {
					result = false;
				}
			} catch (SQLException e) {
				// OfalseƂ
				result = false;
			}
		}

		return result;
	}
	
	private static Map getDsManageMap() {

		if (threadLocal.get() == null)	threadLocal.set(new HashMap());
		
		return (Map)threadLocal.get();
	}
	
	private static void checkBeforeConnection(Map<String, Map> dsManageMap, String detaSourceName) throws SQLException {

		if (dsManageMap.containsKey(detaSourceName)) {
			// N[YRꌟm
			DBConnection beforeConn = (DBConnection) dsManageMap.get(detaSourceName).get(DS_CONNECTION);
			if (!beforeConn.isClosed()) {

				Class beforeClass = (Class) dsManageMap.get(detaSourceName).get(CLASS_NAME);

				DebugLogger.getLogger(DataSourceManager.class).error(
						"RlNV擾ɃN[YRm܂B O擾NX : "
								+ beforeClass.getName());
			}
		}
	}

	private static Connection getConnection(boolean autoCommit) throws SQLException {

		try {
			Class.forName(prop.getDriverName());
			
			Connection conn = DriverManager.getConnection(
					prop.getURL(), 
					prop.getUserName(), 
					prop.getPassword());
			
			return conn;
		} catch (ClassNotFoundException e) {
			e.printStackTrace();
		} catch (SQLException e) {
			e.printStackTrace();
		}
		
		return null;
	}

	/**
	 * 
	 * Tv: f[^\[XRlNV擾܂B<br>
	 * ڍ: f[^\[XRlNV擾܂B<br>
	 * l: Ȃ<br>
	 * 
	 * @param dataSourceName
	 * @return
	 * @throws SQLException
	 */
	private static Connection getConnection(String dataSourceName, boolean autoCommit) throws SQLException {
		try {
			InitialContext context = new InitialContext();

			DataSource ds = (DataSource) context.lookup("java:comp/env/" + dataSourceName);

			Connection connection = ds.getConnection();

			connection.setAutoCommit(autoCommit);

			return connection;

		} catch (NamingException e) {
			// G[
			throw new RuntimeException("JNDỈɎs܂B", e);
		}

	}
}
