package jp.co.infonic.common.module.csv;

import java.util.LinkedList;

/**
 * CSVPs̃R[h͂NX
 * @author higuchi
 *
 */
public class CSVLineParser {

	public static final char DEFAULT_DELIMITER = ',';
	
	private StringBuffer buffer;
	
	int quotNum = 0;
	
	/**
	 * PR[h̃f[^ɕǉ
	 * @param line
	 */
	CSVLineParser appendString(String line) {
		if (buffer == null) buffer = new StringBuffer();
		
		countQuot(line);
		buffer.append(line);
		return this;
	}
	
	/**
	 * PR[h̃f[^͂łf[^Ԃ
	 * @return
	 */
	boolean isCorrectRecord() {
		return isEven(quotNum);
	}
	
	/**
	 * PR[h̕J}ŕzɂĕԂB
	 * @return
	 */
	String[] getSeparatedValues() {
		return getSeparatedValues(DEFAULT_DELIMITER);
	}
	
	/**
	 * PR[h̕񂲂ƂɃf~^wŕzɂĕԂB
	 * @param delimiter f~^
	 * @return
	 */
	String[] getSeparatedValues(char delimiter) {
		String[] cols = splitTokens(String.valueOf(delimiter));
		for (int i = 0; i < cols.length; i++)
			cols[i] = trim(cols[i]).replaceFirst("^\"", "").replaceFirst("\"$", "");
		return cols;
	}
	
	/**
	 * ǂݍ񂾂܂܂̂Ps̕Ԃ
	 * @return
	 */
	String getDefaultString() {
		return buffer.toString();
	}
	
	boolean isNull() {
		return buffer == null;
	}
	
	// obt@̕񂲂Ƃɕ
	private String[] splitTokens(String delimiter) {
		LinkedList tokens = new LinkedList();
		
		String[] splits = buffer.toString().split(delimiter, -1);
		for (int i = 0; i < splits.length; i++) {
			if (tokens.isEmpty() || isCorrectElement((String)tokens.getLast())) {
				tokens.add(splits[i]);
			} else {
				tokens.add( tokens.removeLast() + delimiter + splits[i] );
			}
		}
		
		return (String[])tokens.toArray(new String[0]);
	}
	
	// vf̃f[^`FbN
	private boolean isCorrectElement(String str) {
		return isEven(countChar(str, '"', 0));
	}
	
	// 񒆂̃_uNH[e[V̐𐔂
	private int countQuot(String str) {
		return quotNum += countChar(str, '"', 0);
	}
	
	// 񒆂̃Lij̐𐔂
	private int countChar(String str, char c, int start) {
		int i = 0, index = str.indexOf(c, start);
		return index == -1 ? i : countChar(str, c, index + 1) + 1;
	}
	
	// g~O
	private String trim(String str){
		return str.replaceFirst("^\\s*", "").replaceFirst("\\s*$", "");
	}
	
	private boolean isEven(int value) {
		return value % 2 == EVEN;
	}
	private boolean isOdd(int value) {
		return value % 2 == ODD;
	}
	
	private static final int ODD = 1;
	private static final int EVEN = 0;
}
