package jp.co.infonic.common.module.csv;

import java.io.BufferedReader;
import java.io.File;
import java.io.FileInputStream;
import java.io.IOException;
import java.io.InputStreamReader;
import java.util.Iterator;
import java.util.LinkedList;
import java.util.List;

/**
 * ėpCSVt@CǍCu
 * 
 * ygz
 * CSVReader csv = new CSVReader(ǂݍݑΏۃt@C).preLoadTitleRow(); //--1
 * 
 * while(csv.next()) {
 *   String col1 = csv.get("column1");
 *   String col2 = csv.get("column2");
 * }
 * 
 * JDBCResultSet̂悤ȊoŎgp܂B
 * 
 * 1
 * CSVt@C̐擪s񖼂ɂȂĂꍇ̂
 * preLoadTitleRows܂B
 * ȂĂȂꍇ newA
 * setColumnName(String[] columns)ŗ񖼂ZbgKv܂B
 * 
 * 
 * @author higuchi
 *
 */
public class CSVReader {
	
	public static final String DEFAULT_ENCODE = "Windows-31J";
	
	private File file;
	
	private String encode;
	
	private String[] colmunName;
	
	private Iterator iter;
	
	private CSVRecordMap currentRow;
	
	private String defaultString;
	
	private int currentRowNum = 0;
	
	private boolean EOF = false;

	// ǂݍݍς݂CSVf[^̍s
	private int readBuffer = 1000;

	private int offset = 0;
	
	private int readIndex;
	
	public CSVReader(String fileName) {
		this(new File(fileName), DEFAULT_ENCODE);
	}
	
	public CSVReader(File file) {
		this(file, DEFAULT_ENCODE);
	}
	
	public CSVReader(File file, String encode) {
		this.file = file;
		this.encode = encode;
		iter = new LinkedList().iterator();
	}
	
	/**
	 * t@C̐擪s^Cgǂݍ݂܂
	 * @return
	 * @throws IOException
	 */
	public CSVReader preLoadTitleRow() throws IOException {
		BufferedReader br = null;
		try {
			br = new BufferedReader(new InputStreamReader(new FileInputStream(file),encode));
			CSVLineParser parser = readLine(br, new CSVLineParser());
			offset = readIndex;
			colmunName = parser.getSeparatedValues();
		} finally {
			if (br != null)
				br.close();
		}
		return this;
	}
	
	public void setColumnName(String[] title) {
		this.colmunName = title;
	}
	
	/**
	 * JXg擾܂
	 * @return
	 */
	public String[] columnName() {
		return colmunName;
	}
	
	/**
	 * t@Cǂ݂Ăsw肷B
	 * t@C̓ǂݍ݂͖open,closesׁA
	 * xobt@ĂB
	 * ftHg1000R[hB
	 * @param num
	 */
	public void setBufferSize(int num) {
		this.readBuffer = num;
	}
	
	/**
	 * ݂̃R[h}bvf[^ƂĕԂB
	 * @return
	 */
	public CSVRecordMap currentRow() {
		return currentRow;
	}
	
	/**
	 * ݂̃R[ht@Cǂݍ񂾕̂܂ܕԂB
	 * @return
	 */
	public String defaultString() {
		return defaultString;
	}
	
	/**
	 * ݂̍sԍ擾܂B
	 * @return
	 */
	public int currentRowNumber() {
		return currentRowNum;
	}
	
	/**
	 * ̃R[h̗LԂB
	 * @return
	 */
	public boolean next() {
		if (!iter.hasNext() && !EOF) {
			try {
				iter = readBuffer().iterator();
			} catch (IOException ioe) {
				ioe.printStackTrace();
				return false;
			}
		}

		if (iter.hasNext()) {
			CSVLineParser parser = (CSVLineParser) iter.next();
			defaultString = parser.getDefaultString();
			currentRow = new CSVRecordMap();
			String[] cols = parser.getSeparatedValues();
			for (int i = 0; i < cols.length; i++)
				currentRow.put(colmunName[i], cols[i]);

			currentRowNum++;
			return true;
		} else {
			defaultString = null;
			currentRow = null;
			return false;
		}
	}
	
	/**
	 * JɑΉ錻݃R[h̒lԂB
	 * @param columnName
	 * @return
	 */
	public String get(String columnName) {
		if (currentRow != null) {
			return (String) currentRow.get(columnName);
		}
		return null;
	}

	private List readBuffer() throws IOException {
		List result = new LinkedList();
		BufferedReader br = null;
		readIndex = 0;
		try {
			br = new BufferedReader(new InputStreamReader(new FileInputStream(file), encode));
			seekOffset(br);

			while(result.size() < readBuffer) {
				CSVLineParser record = readLine(br, new CSVLineParser());
				if (EOF = record.isNull())
					break;
				else
					result.add(record);
			}
			offset = readIndex;
		} finally {
			if (br != null) br.close();
		}
		

		return result;
	}
	
	private CSVLineParser readLine(BufferedReader br, CSVLineParser parser) throws IOException {
		String line = br.readLine();
		readIndex++;
		if (line != null && !parser.appendString(line).isCorrectRecord()){
			return readLine(br, parser.appendString(System.getProperty("line.separator")));
		}
		
		return parser;
	}
	
	private void seekOffset(BufferedReader br) throws IOException {
		while (br.ready() && readIndex < offset) {
			br.readLine();
			readIndex++;
		}
	}
}
