package jp.co.infonic.common.module.log;

import jp.co.infonic.inforails.base.exception.SystemException;

import org.apache.log4j.Logger;

/**
 * 
 * TvFG[Oo͂܂B<br>
 * ڍׁFG[Oo͂܂B<br>
 *<pre>
 * [ύX]
 * t        A   O      e
 * --------------------------------------------------
 * 2006/04/02  VL000        VK
 *</pre>
 * @author Tetsuro
 */
public class APErrorLogger extends CommonLogger {

	// K[
	private Logger logger;

	// fobOOpJeS
	private static final String CATEGORY_NAME = "APError.";

	// VXesR[h
	private static final String LINE_SEP = System.getProperty("line.separator");

	// OZp[^
	private static final String LOG_SEP = "------------------------------------------------------------------------------";

	/**
	 * vCx[gRXgN^
	 * 
	 * @param cla
	 */
	private APErrorLogger(String categoryName) {

		logger = Logger.getLogger(CATEGORY_NAME + categoryName);

	}

	/**
	 * 
	 * Tv: K[̎擾s܂B<br>
	 * ڍ: K[̎擾s܂B<br>
	 * l: Ȃ<br>
	 * 
	 * @param cla
	 * @return
	 */
	public static APErrorLogger getLogger() {

		return getLogger(APErrorLogger.class.getName());

	}

	/**
	 * 
	 * Tv: K[̎擾s܂BJeSʂɏo͂ꍇɈ^܂B<br>
	 * ڍ: K[̎擾s܂BJeSʂɃȌo͐sꍇɈ^܂B
	 *       vpeBt@CŃJeSLqۂAPError.JeSŎw肵܂B<br>
	 * l: Ȃ<br>
	 * 
	 * @param cla
	 * @return
	 */
	public static APErrorLogger getLogger(String categoryName) {
		
		if (categoryName == null) {
			categoryName = APErrorLogger.class.getName();
		}
		
		APErrorLogger log = new APErrorLogger(categoryName);

		return log;

	}

	/**
	 * 
	 * Tv: G[Ȍo͂s܂B<br>
	 * ڍ: G[Ȍo͂s܂B<br>
	 * l: Ȃ<br>
	 * 
	 * @param className
	 * @param methodName
	 * @param debugInfo
	 * @param noticeFlg
	 * @param noticeMsg
	 * @param excep
	 */
	public void outputErrorLog(String className, String methodName,
			String debugInfo, boolean noticeFlg, String noticeMsg,
			Throwable excep) {

		StringBuffer sb = new StringBuffer();
		editErrorLogMsg(sb, className, methodName, debugInfo, noticeFlg,
				noticeMsg);
		sb.append(LINE_SEP);

		if (excep != null) {
			if (excep instanceof SystemException) {

				SystemException sysExc = (SystemException) excep;
				Throwable th = sysExc.getCause();
				if (th != null) {
					sb.append(LINE_SEP);
				}

				while (th != null) {
					editStackTrace(sb, th);
					th = th.getCause();
				}
			} else {
				sb.append(LOG_SEP);
				logger.error(sb.toString(), excep);
				return;
			}
		}

		sb.append(LOG_SEP);
		logger.error(sb.toString());

		if (noticeFlg) {
			noticeMsg(sb);
		}
	}

	/**
	 * 
	 * Tv: Ǘ҂֒ʒms܂B<br>
	 * ڍ: Ǘ҂֒ʒms܂Bij<br>
	 * l: Ȃ<br>
	 * 
	 * @param log
	 */
	private void noticeMsg(StringBuffer log) {

	}

	/**
	 * 
	 * Tv: G[OpbZ[WҏW܂B<br>
	 * ڍ: G[OpbZ[WҏW܂B<br>
	 * l: Ȃ<br>
	 * 
	 * @param sb
	 * @param className
	 * @param methodName
	 * @param debugInfo
	 * @param noticeFlg
	 * @param noticeMsg
	 * @return
	 */
	private StringBuffer editErrorLogMsg(StringBuffer sb, String className,
			String methodName, String debugInfo, boolean noticeFlg,
			String noticeMsg) {
		if (methodName == null) {
			methodName = "";
		}
		if (debugInfo == null) {
			debugInfo = "";
		}
		if(noticeMsg == null) {
			noticeMsg = "";
		}

		sb.append(className).append(",");
		sb.append(methodName).append(",");
		sb.append(debugInfo).append(",");

		if (commonInfo() != null) {
			sb.append(",").append(commonInfo().toLogFormat());
		}

		sb.append(noticeFlg).append(",");
		sb.append(noticeMsg);
		return sb;
	}

	/**
	 * 
	 * Tv: Og[XҏWB<br>
	 * ڍ: Og[XҏWB<br>
	 * l: Ȃ<br>
	 * 
	 * @param sb
	 * @param th
	 * @return
	 */
	private StringBuffer editStackTrace(StringBuffer sb, Throwable th) {

		// ObZ[WҏW
		sb.append(th.getClass().getName()).append(th.getMessage()).append(
				LINE_SEP);

		// Oڍ׃g[X擾
		StackTraceElement[] element = th.getStackTrace();
		for (int i = 0; i < element.length; i++) {

			// Oڍ׃g[XҏW
			sb.append("\tat ").append(element[i]).append(LINE_SEP);
		}

		// ҏWobt@ԋp
		return sb;
	}

}
