package jp.co.infonic.common.module.log;

import java.util.LinkedList;
import java.util.List;

import jp.co.infonic.common.util.ArrayUtil;

import org.apache.log4j.Logger;

/**
 * 
 * TvFob`K[<br>
 * ڍׁFob`K[<br>
 *<pre>
 * [ύX]
 * t        A   O      e
 * --------------------------------------------------
 * 2006/10/01  VL000        VK
 *</pre>
 * @author higuchit
 */
public class BatchLogger {
	
	// ob`OpJeS
	private static final String CATEGORY_NAME = "Batch.";
	
	/**
	 * Tv: K[擾B<br>
	 * ڍ: K[擾B<br>
	 * l: Ȃ<br>
	 *
	 * @param cla
	 * @return
	 */
	public static BatchLogger getLogger(Class batchClass) {
		return new BatchLogger(batchClass);
	}
	
	private String name;
	
	// K[
	private Logger logger;
	
	// ob`Jn
	private long starttime;
	
	// ob`I
	private long endtime;
	
	private BatchLogger(Class batchClass) {
		Class category = batchClass == null ? BatchLogger.class : batchClass;
		this.logger = Logger.getLogger(CATEGORY_NAME + category.getName());
		this.name = batchClass.getSimpleName();
	}
	
	/**
	 * 
	 * Tv: fobOxŃbZ[Wo͂B<br>
	 * ڍ: fobOxŃbZ[Wo͂B<br>
	 * l: Ȃ<br>
	 *
	 * @param msg
	 */
	public void debug(String message) {
		List <String>contents = createLogMsg();
		contents.add(message);
		logger.debug(ArrayUtil.join(contents, ","));
	}
	
	/**
	 * 
	 * Tv: fobOxŃbZ[Wo͂B<br>
	 * ڍ: fobOxŃbZ[Wo͂B<br>
	 * l: Ȃ<br>
	 *
	 * @param msg
	 */
	public void debug(String message, Throwable e) {
		List <String>contents = createLogMsg();
		contents.add(message);
		logger.debug(ArrayUtil.join(contents, ","), e);
	}
	
	/**
	 * 
	 * Tv: CtHxŃbZ[Wo͂B<br>
	 * ڍ: CtHxŃbZ[Wo͂B<br>
	 * l: Ȃ<br>
	 *
	 * @param msg
	 */
	public void info(String message) {
		List <String>contents = createLogMsg();
		contents.add(message);
		logger.info(ArrayUtil.join(contents, ","));
	}
	
	/**
	 * 
	 * Tv: G[o͂s܂B<br>
	 * ڍ: G[o͂s܂B<br>
	 * l: Ȃ<br>
	 *
	 * @param message
	 * @param th
	 */
	public void error(Throwable th) {
		logger.error(th);
	}
	
	/**
	 * Tv: ob`OɗÕg[Xo͂܂B<br>
	 * ڍ: ob`OɗÕg[Xo͂܂B<br>
	 * l: Ȃ<br>
	 *
	 * @param e
	 */
	public void exception(Throwable e) {
		logger.error(e);
	}
	
	public void start() {
		starttime = System.currentTimeMillis();
		List <String>contents = createLogMsg();
		contents.add("Jn");
		logger.info(ArrayUtil.join(contents, ","));
	}
	
	/**
	 * 
	 * Tv: ob`̏IOo͂܂B<br>
	 * ڍ: ob`̏IOo͂܂B<br>
	 * l: Ȃ<br>
	 *
	 * @param status
	 */
	public void end(int status) {
		endtime = System.currentTimeMillis();
		List <String>contents = createLogMsg();
		contents.add("I");
		contents.add("[result]" + status);
		contents.add("[starttime]" + starttime);
		contents.add("[endtime]" + endtime);
		contents.add("[processtime]" + (endtime - starttime));
		logger.info(ArrayUtil.join(contents, ","));
	}
	
	/**
	 * Tv: ob`OʃbZ[W𐶐
	 *
	 * @return
	 */
	private List<String> createLogMsg() {
		List<String> contents = new LinkedList<String>();
		contents.add(this.name);
		contents.add(Thread.currentThread().getName());
		return contents;
	}

}
